<?php
/*
Plugin Name: Editor Template
Plugin URI: 
Description: 投稿画面のテンプレート
Author: Prime Strategy Co.,LTD.
Version: 0.1
Author URI: 
*/
class editor_template {
	var $meta_keys = array(
		'Q1A7',
		'Q3',
		'Q3A9',
		'Q4',
		'Q4A5',
		'Q5',
		'Q6U1U',
		'Q6U1V',
		'Q6D1U',
		'Q6D1V',
		'Q6T1U',
		'Q6T1V',
		'Q6U2U',
		'Q6U2V',
		'Q6D2U',
		'Q6D2V',
		'Q6T2U',
		'Q6T2V',
		'Q6U3U',
		'Q6U3V',
		'Q6D3U',
		'Q6D3V',
		'Q6T3U',
		'Q6T3V',
		'Q6UKU',
		'Q6UKV',
		'Q6U4U',
		'Q6U4V',
		'Q6D4U',
		'Q6D4V',
		'Q6T4U',
		'Q6T4V',
		'Q6U5U',
		'Q6U5V',
		'Q6D5U',
		'Q6D5V',
		'Q6T5U',
		'Q6T5V',
		'Q6U6U',
		'Q6U6V',
		'Q6D6U',
		'Q6D6V',
		'Q6T6U',
		'Q6T6V',
		'Q6U7U',
		'Q6U7V',
		'Q6D7U',
		'Q6D7V',
		'Q6T7U',
		'Q6T7V',
		'Q6UHU',
		'Q6UHV',
		'Q6LT',
		'Q7',
		'Q7A10',
		'Q8'
	);
	

	var $required_items = array(

	);

function __construct() {
	// カスタム分類（使用期間）の追加
	add_action( 'init'							, array( &$this, 'add_custom_taxonomies' ) );

	// 翻訳変更
	add_filter( 'gettext'								, array( &$this, 'replace_post_translate' ), 10, 3 );
	add_filter( 'gettext_with_context'					, array( &$this, 'trans_replace_post_translate' ), 10, 4 );
	add_filter( 'ngettext'								, array( &$this, 'trans_replace_post_translate' ), 10, 5 );
	add_filter( 'ngettext_with_context'					, array( &$this, 'trans_replace_post_translate' ), 10, 6 );

	if ( is_admin() ) {
		// 専用テンプレートへの変更
		add_action( 'load-post.php'							, array( &$this, 'custom_post_edit_admin' ) );
		add_action( 'load-post-new.php'						, array( &$this, 'custom_post_edit_admin' ) );
		
		// レイアウトを１カラム固定に
		add_filter( 'get_user_option_screen_layout_post', array( &$this, 'post_edit_fix_layout' ) );
		add_filter( 'screen_layout_columns'				, array( &$this, 'post_edit_fix_max_columns' ) );

		// 不要な連絡情報欄を削除
		add_filter( 'user_contactmethods'					, '__return_empty_array' );

		// 更新データ処理、公開必須チェック
		add_action( 'wp_insert_post'						, array( &$this, 'update_process_event_info' ), 10, 2 );

		// 投稿からeditorを削除&editor.jsを追加
		add_action( 'init'									, array( &$this, 'remove_post_editor_support' ) );

		// 必須項目チェック
//		add_action( 'wp_insert_post'						, array( &$this, 'check_required_item' ), 9999, 2 );
		
		// メディアのFlashアップローダーを無効化する
//		add_filter( 'flash_uploader'						, '__return_false' );
		
	}
}


function custom_post_edit_admin() {
	global $pagenow, $typenow;
	if ( $pagenow == 'post.php' ) {
		$post = (int)$_GET['post'];
		$post = get_post( $post );
		$post_type = $post->post_type;
	} else {
		$post_type = $typenow;
	}

	if ( $post_type == 'post' ) {
		// 投稿画面の不要なボックスを削除
		add_action( 'add_meta_boxes'					, array( &$this, 'remove_default_metaboxes' ), 10, 2 );

		// 投稿画面の公開ボックスを再追加、イベント情報のボックスを追加
		add_action( 'add_meta_boxes'					, array( &$this, 'add_event_metabox' ), 10, 2 );
		add_action( 'admin_print_styles-post.php'		, array( &$this, 'output_editor_style' ) );
		add_action( 'admin_print_styles-post-new.php'	, array( &$this, 'output_editor_style' ) );
		
	}
}


function add_custom_taxonomies() {
	$args = array(
		'label' => '使用期間',
		'labels' => array(
			'name' => '使用期間',
			'singular_name' => '使用期間',
			'search_items' => '使用期間を検索',
			'popular_items' => '多い使用期間',
			'all_items' => '使用期間',
			'parent_item' => '上位会場',
			'edit_item' => '使用期間の編集',
			'update_item' => '更新',
			'add_new_item' => '使用期間の追加',
			'new_item_name' => '新しい使用期間',
		),
		'public' => true,
		'show_ui' => true,
		'hierarchical' => true,
		'show_tagcloud' => false,
		'show_in_nav_menus' => true
	);
	register_taxonomy( 'duration', array( 'post' ), $args );
}


function remove_post_editor_support() {
	remove_post_type_support( 'post', 'editor' );
}


function post_edit_fix_layout() {
	return 1;
}


function post_edit_fix_max_columns( $columns ) {
	$columns['post'] = 1;
	return $columns;
}

function add_event_metabox( $post_type, $post ) {
	add_meta_box( 'enquete_meta_box', 'アンケート', array( &$this, 'event_meta_box' ), $post_type, 'normal', 'high');
	add_meta_box( 'submitdiv', __('Publish'), 'post_submit_meta_box', $post_type, 'normal', 'high' );
}


function remove_default_metaboxes( $post_type, $post ) {
	$meta_boxes = array(
		'side'		=> array( 'submitdiv', 'tagsdiv-post_tag', 'categorydiv', 'durationdiv', 'postimagediv' ),
		'normal'	=> array( 'trackbacksdiv', 'commentstatusdiv', 'commentsdiv', 'postexcerpt', 'postcustom', 'slugdiv', 'authordiv', 'revisionsdiv' )
	);
	
	foreach ( $meta_boxes as $position => $boxes ) {
		foreach ( $boxes as $box ) {
			remove_meta_box( $box, $post_type, $position );
		}
	}
}


function event_meta_box() {
	global $post, $ans_map;
	$categories = get_categories( 'orderby=order&hide_empty=0&exclude=' . get_option( 'default_category' ) );
	$post_categories = get_the_terms( $post->ID, 'category' );
	if ( $post_categories ) {
		$post_categories = $this->get_opject_fields( $post_categories, 'term_id' );
	} else {
		$post_categories = array( get_option( 'default_category' ) );
	}
	$durations = get_terms( 'duration', 'orderby=order&hide_empty=0' );

	$post_durations = get_the_terms( $post->ID, 'duration' );
	if ( $durations ) {
		$post_durations = $this->get_opject_fields( $post_durations, 'term_id' );
	} else {
		$post_durations = array();
	}

	$customs = get_post_custom( $post->ID );
	$post_customs = array();
	foreach ( $this->meta_keys as $meta_key ) {
		if ( isset( $customs[$meta_key][0] ) ) {
			if ( count( $customs[$meta_key] ) == 1 ) {
				$post_customs[$meta_key] = $customs[$meta_key][0];
			} else {
				$post_customs[$meta_key] = $customs[$meta_key];
			}
		} else {
			$post_customs[$meta_key] = '';
		}
	}


	$author = get_userdata( $post->post_author );

	include( dirname( __FILE__ ) . '/tpl/post.php' );
}


function update_process_event_info( $post_id, $post ) {
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE && ! (int)$post_id ) { return; }

	if ( in_array( $post->post_status, array( 'draft', 'publish', 'protected', 'future' ) ) ) {
		$post_data = stripslashes_deep( $_POST );
		
		foreach ( $this->meta_keys as $meta_key ) {
			if ( isset( $post_data[$meta_key] ) ) {
				if ( preg_match( '/^Q6(U|D|T)/', $meta_key ) ) {
					$post_data[$meta_key] = mb_convert_kana( $post_data[$meta_key], 'a', 'UTF-8' );
					$post_data[$meta_key] = preg_replace( '/[^\d\.]/', '', $post_data[$meta_key] );
					if ( $post_data[$meta_key] < 1 || $post_data[$meta_key] > 5 ) {
						$post_data[$meta_key] = '';
					}
				}
				if ( in_array( $meta_key, array( 'Q4', 'Q7', 'Q6LT' ) ) ) {
					delete_post_meta( (int)$post_id, $meta_key );
					foreach ( $post_data[$meta_key] as $post_val ) {
						add_post_meta( (int)$post_id, $meta_key, $post_val );
					}
				} else {
					update_post_meta( (int)$post_id, $meta_key, $post_data[$meta_key] );
				}
			}
		}
	}
}


function output_editor_style() {
	$css_url = preg_replace( '/^https?:/', '', plugin_dir_url( __FILE__ ) ) . 'css/post_admin.css';
?>
<link rel="stylesheet"  href="<?php echo esc_url( $css_url ); ?>" type="text/css" media="all" />
<?php
}


function replace_post_translate( $translated, $text, $domain ) {
	$custom_translates = array(
		'default' => array(
			'予約投稿' => '公開予約',
			'投稿' => 'アンケート',
			'カテゴリー' => '使用用途',
			'タイトルを入力してください' => 'アンケート識別IDを入力してください',
			'作成者' => '入力者',
		)
	);
	if ( isset( $custom_translates[$domain] ) ) {
		$translated = str_replace( array_keys( $custom_translates[$domain] ), $custom_translates[$domain], $translated );
	}
	return $translated;
}


function trans_replace_post_translate() {
	$args = func_get_args();
	$translated = $args[0];
	$text = $args[1];
	$domain = array_pop( $args );
	$translated = $this->replace_post_translate( $translated, $text, $domain );
	return $translated;
}


function get_opject_fields( $objects, $field = 'ID' ) {
	if ( ! is_array( $objects ) ) { return array(); }
	$fields = array();
	foreach( $objects as $object ) {
		if ( isset( $object->$field ) ) {
			$fields[] = $object->$field;
		}
	}
	return $fields;
}


function addslashes_deep($value) {
	if ( is_array($value) ) {
		$value = array_map( array( $this, 'addslashes_deep' ), $value);
	} elseif ( is_object($value) ) {
		$vars = get_object_vars( $value );
		foreach ($vars as $key=>$data) {
			$value->{$key} = $this->addslashes_deep( $data );
		}
	} else {
		$value = addslashes($value);
	}
	return $value;
}


function get_empty_required_item( $post ) {
	
	$customs = get_post_custom( $post->ID );
	$empty_items = array();

	foreach ( $this->required_items as $item => $item_name ) {
		switch ( $item ) {
		default :
			if ( ! isset( $customs[$item][0] ) || ! $customs[$item][0] ) {
				$empty_items[$item] = $item_name;
			}
		}
	}
	return $empty_items;
}


} // class end

$editor_template = new editor_template();
